FileReader (Java SE 14 & JDK 14)
Description: declaration: module: java.base, package: java.io, class: FileReader
Keywords: java.io.FileReader class

Module java.base
Package java.io

# Class FileReader

java.lang.Object
java.io.Reader
java.io.InputStreamReader
java.io.FileReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Readable`

    public class FileReader
    extends InputStreamReader

Reads text from character files using a default buffer size. Decoding from bytes to characters uses either a specified charset or the platform's default charset.

The `FileReader` is meant for reading streams of characters. For reading streams of raw bytes, consider using a `FileInputStream`.

Since:
  1.1
See Also:
  `InputStreamReader`, `FileInputStream`

- ## Field Summary

  ### Fields declared in class java.io.Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `FileReader​(File file)` | Creates a new `FileReader`, given the `File` to read, using the platform's default charset.
  `FileReader​(FileDescriptor fd)` | Creates a new `FileReader`, given the `FileDescriptor` to read, using the platform's default charset.
  `FileReader​(File file, Charset charset)` | Creates a new `FileReader`, given the `File` to read and the charset.
  `FileReader​(String fileName)` | Creates a new `FileReader`, given the name of the file to read, using the platform's default charset.
  `FileReader​(String fileName, Charset charset)` | Creates a new `FileReader`, given the name of the file to read and the charset.

- ## Method Summary

  ### Methods declared in class java.io.InputStreamReader

  `getEncoding, read, read, ready`

  ### Methods declared in class java.io.Reader

  `close, mark, markSupported, nullReader, read, read, reset, skip, transferTo`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### FileReader

    public FileReader​(String fileName) throws FileNotFoundException
    Creates a new `FileReader`, given the name of the file to read, using the platform's default charset.
    Parameters:
      `fileName` - the name of the file to read
    Throws:
      `FileNotFoundException` - if the named file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading.

  - ### FileReader

    public FileReader​(File file) throws FileNotFoundException
    Creates a new `FileReader`, given the `File` to read, using the platform's default charset.
    Parameters:
      `file` - the `File` to read
    Throws:
      `FileNotFoundException` - if the file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading.

  - ### FileReader

    public FileReader​(FileDescriptor fd)
    Creates a new `FileReader`, given the `FileDescriptor` to read, using the platform's default charset.
    Parameters:
      `fd` - the `FileDescriptor` to read

  - ### FileReader

    public FileReader​(String fileName, Charset charset) throws IOException
    Creates a new `FileReader`, given the name of the file to read and the charset.
    Parameters:
      `fileName` - the name of the file to read
      `charset` - the charset
    Throws:
      `IOException` - if the named file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading.
    Since:
      11

  - ### FileReader

    public FileReader​(File file, Charset charset) throws IOException
    Creates a new `FileReader`, given the `File` to read and the charset.
    Parameters:
      `file` - the `File` to read
      `charset` - the charset
    Throws:
      `IOException` - if the file does not exist, is a directory rather than a regular file, or for some other reason cannot be opened for reading.
    Since:
      11